import { Injectable, ɵɵdefineInjectable, Component, Input, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-attendance-library.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxAttendanceLibraryService {
    constructor() { }
}
NgxAttendanceLibraryService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxAttendanceLibraryService.ctorParameters = () => [];
/** @nocollapse */ NgxAttendanceLibraryService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxAttendanceLibraryService_Factory() { return new NgxAttendanceLibraryService(); }, token: NgxAttendanceLibraryService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-attendance-library.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxAttendanceLibraryComponent {
    constructor() {
        this.yearsArr = ["2020", "2021", "2022", "2023", "2024", "2025"];
        this.yearMonthArr = ["jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec",];
        this.weekDayArr = ["sun", "mon", "tue", "wed", "thu", "fri", "sat"];
        this.weekOne = [];
        this.weekTwo = [];
        this.weekThree = [];
        this.weekFour = [];
        this.weekFive = [];
        this.weekSix = [];
        this.monthArr = [
            { 'weekArr': this.weekOne },
            { 'weekArr': this.weekTwo },
            { 'weekArr': this.weekThree },
            { 'weekArr': this.weekFour },
            { 'weekArr': this.weekFive },
            { 'weekArr': this.weekSix }
        ];
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.selectedMonth = this.monthData;
        this.selectedYear = this.yearData;
        this.usrInputDate = this.selectedMonth + " 1 " + this.selectedYear;
        console.log(this.selectedMonth);
        console.log(this.selectedYear);
        console.log(this.usrInputDate);
        // console.log(this.attendanceData)
        this.calendarInit();
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.selectedMonth = this.monthData;
        this.selectedYear = this.yearData;
        this.usrInputDate = this.selectedMonth + " 1 " + this.selectedYear;
        console.log(this.selectedMonth);
        console.log(this.selectedYear);
        console.log(this.usrInputDate);
        // console.log(this.attendanceData)
        this.calendarInit();
    }
    /**
     * @param {?} val
     * @return {?}
     */
    onChangeMonth(val) {
        // console.log("running")
        this.selectedMonth = val;
        this.usrInputDate = this.selectedMonth + " 1 " + this.selectedYear;
        this.calendarInit();
    }
    /**
     * @param {?} val
     * @return {?}
     */
    onChangeYear(val) {
        // console.log("running")
        this.selectedYear = val;
        this.usrInputDate = this.selectedMonth + " 1 " + this.selectedYear;
        this.calendarInit();
    }
    /**
     * @param {?} arr
     * @return {?}
     */
    checkWeekVal(arr) {
        if (arr[0] === undefined && arr[6] === undefined) {
            return true;
        }
    }
    /**
     * @return {?}
     */
    calendarInit() {
        this.weekOne = [];
        this.weekTwo = [];
        this.weekThree = [];
        this.weekFour = [];
        this.weekFive = [];
        this.weekSix = [];
        /** @type {?} */
        let date = new Date();
        /** @type {?} */
        let inputDate = this.usrInputDate;
        /** @type {?} */
        let newyear2008year = new Date(inputDate).getFullYear();
        /** @type {?} */
        let newyear2008month = new Date(inputDate).getMonth();
        /** @type {?} */
        let newyear2008day = new Date(inputDate).getDate();
        /** @type {?} */
        let findMonthDayCount = new Date(newyear2008year, newyear2008month + 1, 0).getDate();
        // console.log("findMonthDayCount " +findMonthDayCount)
        /** @type {?} */
        let firstDayofMonth = new Date(inputDate).getDay();
        // console.log(firstDayofMonth); 
        // console.log(this.weekDayArr[firstDayofMonth]);
        for (let i = 0; i < 7; i++) {
            this.weekOne[i] = i - firstDayofMonth + 1;
        }
        // console.log(this.weekOne);
        for (let i = 0; i < 7; i++) {
            this.weekTwo[i] = i + this.weekOne[6] + 1;
        }
        // console.log(this.weekTwo);
        for (let i = 0; i < 7; i++) {
            this.weekThree[i] = i + this.weekTwo[6] + 1;
        }
        // console.log(this.weekThree);
        for (let i = 0; i < 7; i++) {
            this.weekFour[i] = i + this.weekThree[6] + 1;
        }
        // console.log(this.weekFour);
        for (let i = 0; i < 7; i++) {
            /** @type {?} */
            let insertVal = i + this.weekFour[6] + 1;
            if (insertVal <= findMonthDayCount) {
                this.weekFive[i] = i + this.weekFour[6] + 1;
            }
            else {
                this.weekFive[i] = undefined;
            }
        }
        // console.log(this.weekFive);
        for (let i = 0; i < 7; i++) {
            /** @type {?} */
            let insertVal = i + this.weekFive[6] + 1;
            if (insertVal <= findMonthDayCount) {
                this.weekSix[i] = i + this.weekFive[6] + 1;
            }
            else {
                this.weekSix[i] = undefined;
            }
        }
        // console.log(this.weekSix);
        this.monthArr[0].weekArr = this.weekOne;
        this.monthArr[1].weekArr = this.weekTwo;
        this.monthArr[2].weekArr = this.weekThree;
        this.monthArr[3].weekArr = this.weekFour;
        this.monthArr[4].weekArr = this.weekFive;
        this.monthArr[5].weekArr = this.weekSix;
        // console.log(this.monthArr[4].weekArr);
    }
    /**
     * @param {?} day
     * @return {?}
     */
    getColor(day) {
        // for single months 
        //  console.log("attendanceData");
        //  console.log(this.monthData)
        // console.log(this.attendanceData[0]);
        /** @type {?} */
        let attendanceData = this.attendanceData[0].data;
        if (this.attendanceData[0].month === this.selectedMonth) {
            for (let i = 0; i < attendanceData.length; i++) {
                if (attendanceData[i].date === day) {
                    // console.log("pass");
                    switch (attendanceData[i].status) {
                        case 'present':
                            return '#aed581';
                        case 'abscent':
                            return '#ef9a9a';
                        case 'woff':
                            return '#ccc';
                    }
                }
            }
        }
    }
}
NgxAttendanceLibraryComponent.decorators = [
    { type: Component, args: [{
                // selector: 'Ngx-NgxAttendanceLibrary',
                selector: 'Ngx-AttendanceCalendar',
                template: "<div class=\"calendar-wrapper\">\n    <div class=\"calendar\">\n      <table >\n        <thead>\n          <tr>\n            <td class=\"table-bordered\" *ngFor=\"let day of weekDayArr\">{{day}}</td>\n          </tr>\n        </thead>\n        <tbody>\n          <tr *ngFor=\"let week of monthArr\">\n            <td class=\"table-bordered text-center\" [hidden]=\"checkWeekVal(week.weekArr)\" *ngFor=\"let day of week.weekArr\" [ngStyle]=\"{'background-color':getColor(day)}\">\n              <span *ngIf=\"day > 0\">{{day}}</span>\n              </td>\n          </tr>\n          </tbody>\n      </table>\n    </div>\n  </div>",
                styles: ["p{font-family:Lato}.table-bordered{border:1px solid #ccc;padding:5px;margin:0}.text-center{text-align:center}"]
            }] }
];
/** @nocollapse */
NgxAttendanceLibraryComponent.ctorParameters = () => [];
NgxAttendanceLibraryComponent.propDecorators = {
    monthData: [{ type: Input }],
    yearData: [{ type: Input }],
    attendanceData: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.monthData;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.yearData;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.attendanceData;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.selectedMonth;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.selectedYear;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.usrInputDate;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.yearsArr;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.yearMonthArr;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.weekDayArr;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.weekOne;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.weekTwo;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.weekThree;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.weekFour;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.weekFive;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.weekSix;
    /** @type {?} */
    NgxAttendanceLibraryComponent.prototype.monthArr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-attendance-library.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxAttendanceLibraryModule {
}
NgxAttendanceLibraryModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxAttendanceLibraryComponent],
                imports: [
                    BrowserModule,
                    CommonModule
                ],
                exports: [NgxAttendanceLibraryComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-attendance-library.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxAttendanceLibraryComponent, NgxAttendanceLibraryModule, NgxAttendanceLibraryService };
//# sourceMappingURL=ngx-attendance-library.js.map
